//    _____ _                       _  _  _    _ _           _  _____          _     _  _
//   / ____) |                     | || || |  | | |         | |/ ____)        | |   | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|| |__| | |_ _ _ __ | | |     ___   __| | ____||_|
//  | |    | |/ _` | __) __)/ _ \        |  __  | __) ` `  \| | |    / _ \ / _` |/ _ \
//  | |____| | (_| |__ \__ \  __/        | |  | | |_| |\ |\ | | |____ (_) | (_| |  __/
//   \_____)_|\__,_|___/___/\___|        |_|  |_|\__)_||_||_|_|\_____)___/ \__,_|\___|
//
//


package cat.lib.codes;

import cat.lib.utils.SetUtils;
import cat.lib.utils.StringUtils;
import java.io.PrintWriter;

/**
 *
 * @author Miquel Abadal i Cervià
 */
public class Htmlcode {

    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //


    private static final char[] HTML_SPECIAL_CHARS = new char[] {   'Ç',        'ç',        'Ñ',        'ñ',        'Ã',        'ã',        'Õ',        'õ',         'Ø',        'ø',        'Å',        'å',       'Ý',        'ý',        'ÿ',         '¨',
                                                                    'Á',        'É',        'Í',        'Ó',        'ú',        'á',        'é',        'í',        'ó',        'ú',        'Ä',        'Ë',         'Ï',        'Ö',        'Ü',        'ä',       'ë',        'ï',        'ö',       'ü',
                                                                    'À',        'È',        'Ì',        'Ò',        'Ù',        'à',        'è',        'è',        'ò',        'ù',        'Â',        'Ê',         'Î',        'Ô',        'Û',        'â',       'ê',        'î',        'ô',       'û',
                                                                    'Ð',        'ð',        'ß',        '¼',        '½',        '¾',        '©',        '®',        'ª',        '¹',        '²',        '³',         'Þ',        'þ',        'Æ',        'æ',       '¡',        '¢',        '€',       '£',       '¥',
                                                                    '§',        '¤',        '¦',        '«',        '»',        '¬',        '¯',        'µ',        '¶',        '•',        '°',        '¸',         '¿',        '×',        '÷',        '±'};

    private static final String[] HTML_SPECIAL_CODES = new String[] { "&Ccedil;", "&ccedil;", "&Ntilde;", "&ntilde;", "&Atilde;", "&atilde;", "&Otilde;", "&otilde;",  "&Oslash;", "&Oslash;", "&Aring;",  "&aring;", "&Yacute;", "&yacute;", "&yuml;",    "&uml;",
                                                                      "&Aacute;", "&Eacute;", "&Iacute;", "&Oacute;", "&uacute;", "&aacute;", "&eacute;", "&iacute;",  "&oacute;", "&uacute;", "&Auml;",   "&Euml;",    "&Iuml;",   "&Ouml;",   "&Uuml;",   "&auml;",  "&euml;",   "&iuml;",   "&ouml;",  "&uuml;",
                                                                      "&Agrave;", "&Egrave;", "&Igrave;", "&Ograve;", "&Ugrave;", "&agrave;", "&egrave;", "&igrave;",  "&ograve;", "&ugrave;", "&Acirc;",  "&Ecirc;",   "&Icirc;",  "&Ocirc;",  "&Ucirc;",  "&acirc;", "&ecirc;",  "&icirc;",  "&ocirc;", "&ucirc;",
                                                                      "&ETH;",    "&eth;",    "&szlig;",  "&frac14;", "&frac12;", "&frac34;", "&copy;",   "&reg;",     "&ordf;",   "&sup1;",   "&sup2;",   "&sup3;",    "&THORN;",  "&thorn;",  "&Aelig;",  "&aelig;", "&iexcl;",  "&cent;",   "&euro;",  "&pound;", "&yen;",
                                                                      "&sect;",   "&curren;", "&brvbar;", "&laquo;",  "&raquo;",  "&not;",    "&macr;",   "&micro;",   "&para;",   "&middot;", "&deg;",    "&cedil;",   "&iquest;", "&times;",  "&divide;", "&plusmn;"};

/*    protected static char[] htmlSpecialChars = new char[]   {'"',  '<',        '&',        '>',        '\n',  '\''};
    protected static String[] htmlCodes = new String[] {"&quot;","&lt;",     "&amp;",    "&gt;",     "<br>", "&acute;"};
*/

    
    //   __  __      _            _                        _             _
    //  |  \/  |    | |          | |                      (_)           | |
    //  | \  / | ___| |_ ___   __| | ___ ___    _ __  _ __ _ _    _  _ _| |_ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)  | `_ \| `__) | |  | | _` | __) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \  | |_) | |  | |\ \/ / (_| | |_\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/  |  __/|_|  |_| \__/ \__,_|\__)___/
    //                                         | |
    //                                         |_|


    // Busca a la llista de codis html el codi amb el contingut "code"
    // Retorna el índex de la posició on s'ha trobat el codi o -1 si no existeix.
    private static int searchHtmlCode (String code) {

        int trobat = -1;
        if (!StringUtils.isEmpty(code)) {

            code = code.toLowerCase();
            int cont1 = 0;
            while (cont1<HTML_SPECIAL_CODES.length && trobat==-1) {
                if (code.equals(HTML_SPECIAL_CODES[cont1])) { trobat = cont1; }
                cont1++;
            }
        }
        return trobat;
    }

    //   __  __      _            _                     _     _ _
    //  |  \/  |    | |          | |                   | |   | |_)
    //  | \  / | ___| |_ ___   __| | ___    _ __  _   _| |_  | |_  ____ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \  | `_ \| | | | `_ \| | |/ ___) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | |_) | |_| | |_) | | | (___\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|  |  __/ \__,_|_,__/|_|_|\____)___/
    //                                     | |
    //                                     |_|

    public static void println (PrintWriter out, String text) {
        out.println (text+"<BR>");
    }



    /**
     * Codifica el text "text" amb el codi html.
     *
     * El codi html codifica els caracters especials de la següent manera:
     * caracter --> "&codi;"
     *
     */
    public static String encodeHtml (String text) {

        StringBuilder res = new StringBuilder ();
        if (text!=null) {
            char caract = '\0';
            for (int cont1=0; cont1<text.length(); cont1++) {
                caract = text.charAt(cont1);

                int index = SetUtils.searchCharInArray(caract, true, HTML_SPECIAL_CHARS);
                if (index!=-1) { res.append (HTML_SPECIAL_CODES[index]); }
                else { res.append(caract); }                
            }
        }

        return res.toString();
    }

    public static String encodeHtmlSpaces (String text) { return StringUtils.substString (text, " ", "&nbsp;"); }

    /**
     * Busca en el text, els caraters especials codificats en html i els
     * retorna amb el seu corresponent codi ASCII
     * 
     * &codi; --> Caracter
     * 
     * Exemple: "Caf&eacute;" --> "Café"
     * 
     * @param text
     * @return
     */
    public static String decodeHtml (String text) {

        StringBuilder res = new StringBuilder (text.length());

        if (text!=null) {
            StringBuilder code = new StringBuilder (10);

            char caract = '\0';
            int cont1=0;
            boolean onCode = false;
            while (cont1<text.length()) {

                caract = text.charAt(cont1);
                switch (caract) {
                    case '&':   code.append (caract); onCode = true; break;
                    case ';':   if (onCode) {
                                    code.append (caract);
                                    int index = searchHtmlCode (code.toString());
                                    if (index!=-1) {
                                        // Si existeix a la taula de codis substitueixo la cadena pel corresponent caràcter.
                                        res.append (HTML_SPECIAL_CHARS[index]);
                                    }
                                    else { res.append (code); }
                                    code.setLength (0);
                                }
                                else { res.append (caract); }
                                break;
                    default:    if (onCode) { code.append (caract); }
                                else { res.append (caract); }
                }
                cont1++;
            }
            if (code.length()>0) { res.append (code); }
        }
        
        return res.toString();
    }
}
