//    _____ _                       _  _  _    _       _  _____          _     _  _
//   / ____) |                     | || || |  | |     (_)/ ____)        | |   | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|| |  | |_ __  _| |     ___   __| | ____||_|
//  | |    | |/ _` | __) __)/ _ \        | |  | | `_  \ | |    / _ \ / _` |/ _ \
//  | |____| | (_| |__ \__ \  __/        | |__| | | | | | |____ (_) | (_| |  __/
//   \_____)_|\__,_|___/___/\___|         \____/|_| |_|_|\_____)___/ \__,_|\___|
//
//


package cat.lib.codes;

import cat.lib.utils.StringToNumber;
import cat.lib.utils.StringUtils;

/**
 *
 * @author Miquel Abadal i Cervià
 */
public class Unicode {

    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //


    //   __  __      _            _                        _             _
    //  |  \/  |    | |          | |                      (_)           | |
    //  | \  / | ___| |_ ___   __| | ___ ___    _ __  _ __ _ _    _  _ _| |_ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)  | `_ \| `__) | |  | | _` | __) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \  | |_) | |  | |\ \/ / (_| | |_\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/  |  __/|_|  |_| \__/ \__,_|\__)___/
    //                                         | |
    //                                         |_|

    /**
     * Decodifica el caracter unicode "unicode" al corresponent caràcter ASCII.
     *
     * "\u0038" --> "1"
     *
     * @param unicode
     * @return
     */
    private static char decodeUnicodeChar (String unicode) {
        unicode = StringUtils.copy (unicode, 2, 4);
        char caract = (char) StringToNumber.intValue (unicode, 16, '\0', null);
        return caract;
    }

    //   __  __      _            _                     _     _ _
    //  |  \/  |    | |          | |                   | |   | |_)
    //  | \  / | ___| |_ ___   __| | ___    _ __  _   _| |_  | |_  ____ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \  | `_ \| | | | `_ \| | |/ ___) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | |_) | |_| | |_) | | | (___\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|  |  __/ \__,_|_,__/|_|_|\____)___/
    //                                     | |
    //                                     |_|



    /**
     * Decodifica un text escrit amb codificació "unicode".
     *
     * @param unicode
     * @return
     */
    public static String decodeUnicode (String text) {

        StringBuffer res = new StringBuffer ();
        StringBuffer unicode = new StringBuffer (6);

        char caract = '\0';
        boolean onUnicode = false;

        for (int cont1=0; cont1<text.length(); cont1++) {
            caract = text.charAt (cont1);
            if (caract=='\\') { onUnicode = true; }

            if (onUnicode) {
                unicode.append(caract);
                if (unicode.length()==2 && caract!='u') {
                    onUnicode = false;
                    res.append (unicode);
                    unicode.setLength (0);
                }
                if (unicode.length()==6) {
                    onUnicode = false;
                    res.append (decodeUnicodeChar (unicode.toString()));
                    unicode.setLength (0);
                }
            }
            else { res.append (caract); }

        }

        return res.toString();
    }


}
