//    _____ _                       _  _  ______ _      _     _ _  _
//   / ____) |                     | || ||  ____)_)    | |   | | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|| |___  _  ___| | __| |_||_|
//  | |    | |/ _` | __) __)/ _ \        |  ___)| |/ _ \ |/ _` |
//  | |____| | (_| |__ \__ \  __/        | |    | |  __/ | (_| |
//   \_____)_|\__,_|___/___/\___|        |_|    |_|\___|_|\__,_|
//
//


package cat.lib.dataBase;

import cat.lib.utils.StringToNumber;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Date;

/**
 *
 * @author Miquel Abadal i Cervià
 */
public class Cell {

    private String columnName;
    private String value;

    public Cell (String columnName, String value) {
        this.columnName = columnName;
        this.value = value;
    }

    public String stringValue () { return value; }

    public char charValue () {
        if (value!=null && value.length()>=1) { return value.charAt(0); }
        else { return 0; }
    }

    public boolean booleanValue () { return StringToNumber.booleanValue (value); }
    public byte byteValue () { return StringToNumber.byteValue (value); }
    public short shortValue () { return StringToNumber.shortValue (value); }
    public int intValue () { return StringToNumber.intValue (value); }
    public long longValue () { return StringToNumber.longValue (value); }
    public float floatValue () { return StringToNumber.floatValue (value); }
    public double doubleValue () { return StringToNumber.doubleValue (value); }

    public Date dateValue (String format) { return StringToNumber.dateValue (value, format); }
    public Date dateValue() { return StringToNumber.dateValue (value, "dd-MM-yyyy HH:mm:ss"); }

    public Time timeValue () { return null; }
    public Timestamp timeStampValue () { return null; }

    public boolean booleanValue (boolean errorValue) { return StringToNumber.booleanValue (value, errorValue); }
    public byte byteValue (byte errorValue) { return StringToNumber.byteValue (value, errorValue); }
    public short shortValue (short errorValue) { return StringToNumber.shortValue (value, errorValue); }
    public int intValue (int errorValue) { return StringToNumber.intValue (value, errorValue); }
    public long longValue (long errorValue) { return StringToNumber.longValue (value, errorValue); }
    public float floatValue (float errorValue) { return StringToNumber.floatValue (value, errorValue); }
    public double doubleValue (double errorValue) { return StringToNumber.doubleValue (value, errorValue); }

    public String getColumnName () { return columnName; }

}
