//    _____ _                       _  _  ______ _ _      _____        ___   _  _
//   / ____) |                     | || ||  ____)_) |    (_   _)      / __) | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|| |___  _| | ___  | |  _ __ | |_ ____||_|
//  | |    | |/ _` | __) __)/ _ \        |  ___)| | |/ _ \ | | | `_  \  _| _ \
//  | |____| | (_| |__ \__ \  __/        | |    | | |  __/_| |_| | | | || (_) |
//   \_____)_|\__,_|___/___/\___|        |_|    |_|_|\___|_____)_| |_|_| \___/
//
//


package cat.lib.files;

import java.io.File;

/**
 *
 * @author Miquel Abadal i Cervià
 */
public class FileInfo {

    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //

    private String fileName = null;
    private String filePath = null;
    private long lastModified = 0;
    private boolean isReadOnly = false;
    private boolean isDirectory = false;
    private boolean isFile = false;
    private boolean isHidden = false;
    private long fileSize = 0;



    //   __  __      _            _                              _                    _
    //  |  \/  |    | |          | |                            | |                  | |
    //  | \  / | ___| |_ ___   __| | ___     ____ ___  _ __  ___| |_ _ __ _   _  ____| |_ ___  _ __
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \   / ___) _ \| `_  \ __) __) `__) | | |/ ___) __) _ \| `__)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | (___ (_) | | | |__ \ |_| |  | |_| | (___| |_ (_) | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|   \____)___/|_| |_|___/\__)_|   \__,_|\____)\__)___/|_|
    //
    //

    public FileInfo (File file) {

        if (file!=null) {
            try {
                this.lastModified = file.lastModified();
                this.isReadOnly = file.canWrite();
                this.fileName = file.getName();
                this.filePath = file.getPath();
                this.isDirectory = file.isDirectory();
                this.isFile = file.isFile();
                this.isHidden = file.isHidden();
                this.fileSize = file.length();
            }
            catch (Exception e) {}
        }
    }

    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| |  __| |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)        | | (_ |  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \        | |__| | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/         \_____|______)  |_|
    //
    //

    public String getFileName() { return fileName; }
    public String getFilePath() { return filePath; }
    public long getLastModified() { return lastModified; }
    public long getFileSize() { return fileSize; }
    public boolean isReadOnly() { return isReadOnly; }
    public boolean isDirectory() { return isDirectory; }
    public boolean isHidden() { return isHidden; }
    public boolean isFile() { return isFile; }


    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| (___ | |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)         \___ \|  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \         ____) | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/        (_____/|______)  |_|
    //
    //

    public void setFileName (String fileName) { this.fileName = fileName; }
    public void setFilePath (String filePath) { this.filePath =  filePath; }
    public void setLastModified (long lastModified) { this.lastModified =  lastModified; }
    public void setFileSize (long fileSize) { this.fileSize =  fileSize; }
    public void setIsReadOnly (boolean isReadOnly) { this.isReadOnly =  isReadOnly; }
    public void setIsDirectory (boolean isDirectory) { this.isDirectory =  isDirectory; }
    public void setIsHidden (boolean isHidden) { this.isHidden =  isHidden; }
    public void setIsFile (boolean isFile) { this.isFile =  isFile; }

}
