//    _____ _                       _  _   _____                      _       ______ _ _     _  _
//   / ____) |                     | || | / ____)                    (_)     |  ____)_) |   | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|| |  __  ___ _ __   ___ _ __ _  ____| |___  _| | ____||_|
//  | |    | |/ _` | __) __)/ _ \        | | (_ |/ _ \ `_  \/ _ \ `__) |/ ___)  ___)| | |/ _ \
//  | |____| | (_| |__ \__ \  __/        | |__| |  __/ | | |  __/ |  | | (___| |    | | |  __/
//   \_____)_|\__,_|___/___/\___|         \_____|\___|_| |_|\___|_|  |_|\____)_|    |_|_|\___|
//
//


package cat.lib.files;

import cat.lib.errors.ErrorEx;
import java.io.File;

/**
 *
 * @author Miquel Abadal i Cervià
 */
public abstract class GenericFile {

    //    _____                _              _          _          _        _ _           _                   _        _   _
    //   / ____)              | |            | |        (_)        | |      (_) |         | |                 | |      | | (_)
    //  | |     ___  _ __  ___| |_  _ _ _ __ | |_ ___    _      _ _| |_ _ __ _| |_   _   _| |_ ___     ___ ___| |_  _ _| |_ _  ____ ___
    //  | |    / _ \| `_  \ __) __) _` | `_  \ __) __)  | |   / _` | __) `__) | `_ \| | | | __) __)   / _ \ __) __) _` | __) |/ ___) __)
    //  | |____ (_) | | | |__ \ |_ (_| | | | | |_\__ \  | |  | (_| | |_| |  | | |_) | |_| | |_\__ \  |  __/__ \ |_ (_| | |_| | (___\__ \
    //   \_____)___/|_| |_|___/\__)__,_|_| |_|\__)___/  |_|   \__,_|\__)_|  |_|_,__/ \__,_|\__)___/   \___|___/\__)__,_|\__)_|\____)___/
    //
    //

    protected static final int ST_CLOSED = 0;
    protected static final int ST_READ_ONLY = 1;
    protected static final int ST_WRITE_ONLY = 2;
    protected static final int ST_READ_WRITE = 3;


    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //

    protected int status = ST_CLOSED;
    protected String fileName = null;


    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| |  __| |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)        | | (_ |  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \        | |__| | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/         \_____|______)  |_|
    //
    //

    public String getFileName () { return fileName; }


    public FileInfo getFileInfo (String fileName, ErrorEx error) {

        FileInfo fileInfo = null;
            if (fileName!=null) {
            try { fileInfo = new FileInfo (new File (fileName)); }
            catch (Exception e) {}
        }
        else { error.setError ("IOEXCEPTION", "ACTION: GET_FILE_INFO", "TRACE:FileEx.getFileInfo", "DESCRIPTION: FILE_NOT_FOUND", "FILENAME: NULL"); }

        return fileInfo;
    }

    
    //   __  __      _            _                   _         _                   _
    //  |  \/  |    | |          | |                 | |       | |                 | |
    //  | \  / | ___| |_ ___   __| | ___ ___      _ _| |_   ___| |_ _ __  _ _  ____| |_ ___ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)   / _` | `_ \/ __) __) `__) _` |/ ___) __) _ \ __)
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \  | (_| | |_) |__ \ |_| | | (_| | (___| |_  __/__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/   \__,_|_,__/(___/\__)_|  \__,_|\____)\__)___|___/
    //
    //

    public abstract void reset (String fileName, ErrorEx error);
    public abstract void close (ErrorEx error);
    
}
