//    _____ _                       _  _  _______        _   ______ _ _     _  _
//   / ____) |                     | || |(__   __)      | | |  ____)_) |   | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|   | | ____   __ |_| |___  _| | ____||_|
//  | |    | |/ _` | __) __)/ _ \           | |/ _ \ \/ / __)  ___)| | |/ _ \
//  | |____| | (_| |__ \__ \  __/           | |  __/)  (| |_| |    | | |  __/
//   \_____)_|\__,_|___/___/\___|           |_|\___|_/\_\\__)_|    |_|_|\___|
//
//


package cat.lib.files;

import cat.lib.errors.ErrorEx;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;

/**
 *
 * @author Miquel Abadal i Cervià
 */
public class TextFile extends GenericFile {


    //    _____                _              _          _          _        _ _           _                   _        _   _
    //   / ____)              | |            | |        (_)        | |      (_) |         | |                 | |      | | (_)
    //  | |     ___  _ __  ___| |_  _ _ _ __ | |_ ___    _      _ _| |_ _ __ _| |_   _   _| |_ ___     ___ ___| |_  _ _| |_ _  ____ ___
    //  | |    / _ \| `_  \ __) __) _` | `_  \ __) __)  | |   / _` | __) `__) | `_ \| | | | __) __)   / _ \ __) __) _` | __) |/ ___) __)
    //  | |____ (_) | | | |__ \ |_ (_| | | | | |_\__ \  | |  | (_| | |_| |  | | |_) | |_| | |_\__ \  |  __/__ \ |_ (_| | |_| | (___\__ \
    //   \_____)___/|_| |_|___/\__)__,_|_| |_|\__)___/  |_|   \__,_|\__)_|  |_|_,__/ \__,_|\__)___/   \___|___/\__)__,_|\__)_|\____)___/
    //
    //


    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //

    
    private BufferedReader fileIn = null;
    private PrintWriter fileOut = null;
    


    //   __  __      _            _                              _                    _
    //  |  \/  |    | |          | |                            | |                  | |
    //  | \  / | ___| |_ ___   __| | ___     ____ ___  _ __  ___| |_ _ __ _   _  ____| |_ ___  _ __
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \   / ___) _ \| `_  \ __) __) `__) | | |/ ___) __) _ \| `__)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | (___ (_) | | | |__ \ |_| |  | |_| | (___| |_ (_) | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|   \____)___/|_| |_|___/\__)_|   \__,_|\____)\__)___/|_|
    //
    //

    public TextFile () {}


    //   __  __      _            _                     _     _ _
    //  |  \/  |    | |          | |                   | |   | |_)
    //  | \  / | ___| |_ ___   __| | ___    _ __  _   _| |_  | |_  ____ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \  | `_ \| | | | `_ \| | |/ ___) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | |_) | |_| | |_) | | | (___\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|  |  __/ \__,_|_,__/|_|_|\____)___/
    //                                     | |
    //                                     |_|

    public void rewrite (String fileName, String encoding, ErrorEx error) {

        if (status==ST_CLOSED) {
            if (fileName!=null) {
                try {
                    fileOut = new PrintWriter (fileName, encoding);
                    //fileOut = new PrintWriter (new FileOutputStream (fileName));

                    if (fileOut!=null) {
                        status = ST_WRITE_ONLY;
                        this.fileName = fileName;
                    }
                    else { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: CANT_CREATE_FILE", "FILENAME: "+fileName); }
                }
                catch (FileNotFoundException ex) { error.setError ("IOEXCEPTION", "ACTION: REWRITE", "TRACE:FileEx.rewrite", "DESCRIPTION: FILE_NOT_FOUND", "EXCEPTION:"+ex.getMessage()); }
                catch (UnsupportedEncodingException ex) { error.setError ("IOEXCEPTION", "ACTION: REWRITE", "TRACE:FileEx.rewrite", "DESCRIPTION: BAD ENCODGING", "EXCEPTION:"+ex.getMessage()); }
            }
            else { error.setError ("IOEXCEPTION", "ACTION: REWRITE", "TRACE:FileEx.rewrite", "DESCRIPTION: FILE_NOT_FOUND", "FILENAME: NULL"); }
        }
        else { error.setError ("IOEXCEPTION", "ACTION: REWRITE", "TRACE:FileEx.rewrite", "DESCRIPTION: FILE_ALREADY_OPENED"); }

    }

    public void rewrite (String fileName, ErrorEx error) { rewrite (fileName, "utf-8", error); }

    public void reset (InputStream in, String encoding, ErrorEx error) {

        if (status==ST_CLOSED) {

            try {
                fileIn = new BufferedReader (new InputStreamReader (in, encoding));

                if (fileIn!=null) {
                    status = ST_READ_ONLY;
                    this.fileName = "stream";
                }
                else { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: CANT_OPEN_FILE", "FILENAME: "+fileName); }
            }
            catch (UnsupportedEncodingException ex) { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: BAD ENCODGING", "FILENAME:"+fileName, "EXCEPTION:"+ex.getMessage()); }

        }
        else { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: FILE_ALREEADY_OPENED"); }

    }

    public void reset (String fileName, String encoding, ErrorEx error) {

        if (status==ST_CLOSED) {
            if (fileName!=null) {
                try {
                    fileIn = new BufferedReader (new InputStreamReader (new FileInputStream (fileName), encoding));

                    if (fileIn!=null) {
                        status = ST_READ_ONLY;
                        this.fileName = fileName;
                    }
                    else { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: CANT_OPEN_FILE", "FILENAME: "+fileName); }
                }
                catch (FileNotFoundException ex) { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: FILE_NOT_FOUND", "FILENAME:"+fileName, "EXCEPTION:"+ex.getMessage()); }
                catch (UnsupportedEncodingException ex) { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: BAD ENCODGING", "FILENAME:"+fileName, "EXCEPTION:"+ex.getMessage()); }
            }
            else { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: FILE_NOT_FOUND", "FILENAME: NULL"); }
        }
        else { error.setError ("IOEXCEPTION", "ACTION: RESET", "TRACE:FileEx.reset", "DESCRIPTION: FILE_ALREEADY_OPENED"); }

    }

    public void reset (String fileName, ErrorEx error) { reset (fileName, "utf-8", error); }

    public void write (String text) {

        if (status==ST_WRITE_ONLY) {
            try { fileOut.println(text); fileOut.flush(); }
            catch (Exception ex) {  }
        }
    }


    public void write (String text, ErrorEx error) {

        if (status==ST_WRITE_ONLY) {
            try { fileOut.print(text); fileOut.flush(); }
            catch (Exception ex) { error.setError ("IOEXCEPTION", "ACTION: WRITE", "TRACE:TextFile.write", "DESCRIPTION: WRITE_ERROR"); }
        }
        else { error.setError ("IOEXCEPTION", "ACTION: WRITE", "TRACE:TextFile.write", "DESCRIPTION: FILE_IS_READONLY"); }
    }

    public void writeLine (String text, ErrorEx error) {

        if (status==ST_WRITE_ONLY) {
            try { fileOut.println(text); fileOut.flush(); }
            catch (Exception ex) { error.setError ("IOEXCEPTION", "ACTION: WRITE", "TRACE:TextFile.write", "DESCRIPTION: WRITE_ERROR"); }
        }
        else { error.setError ("IOEXCEPTION", "ACTION: WRITE", "TRACE:TextFile.write", "DESCRIPTION: FILE_IS_READONLY"); }


    }

    public String readLine () {

        String res = null;
        if (status==ST_READ_ONLY) {
            try { res = fileIn.readLine(); }
            catch (IOException ex) {  }
        }
        return res;
    }

    public String readLine (ErrorEx error) {

        String res = null;

        if (status==ST_READ_ONLY) {

            try { res = fileIn.readLine(); }
            catch (IOException ex) { error.setError ("IOEXCEPTION", "ACTION: READ", "TRACE:TextFileEx.read", "DESCRIPTION: "+ex.getMessage()); }
        }
        else { error.setError ("IOEXCEPTION", "ACTION: READ", "TRACE:TextFileEx.read", "DESCRIPTION: FILE_IS_WRITE_ONLY"); }

        return res;
    }

    public String read (ErrorEx error) {

        StringBuilder res = new StringBuilder();

        String line = readLine (error);
        while (error.getError()==null && line!=null) {
            res.append(line);
            line = readLine(error);
        }
        return res.toString();
    }

    public void close (ErrorEx error) {

        if (status!=ST_CLOSED) {
            try {
                if (fileIn!=null) { fileIn.close(); }
                if (fileOut!=null) { fileOut.close(); }
                fileIn = null;
                fileOut = null;
                fileName = null;
            }
            catch (IOException ex) { error.setError ("IOEXCEPTION", "ACTION: CLOSE", "TRACE:TextFile.close", "DESCRIPTION: "+ex.getMessage()); }
        }
        else { error.setError ("IOEXCEPTION", "ACTION: CLOSE", "TRACE:TextFile.close", "DESCRIPTION: FILE_ALREADY_CLOSED"); }
        status = ST_CLOSED;
    }
}
