/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cat.lib.geometry;

/**
 *   _____ _                       _  _    __                 _  _
 *  / ____) |                     | || | / __ \              | || |
 * | |    | |  _ _ ___ ___  ___   |_||_|| |__| |_ __ ___   _ __||_|
 * | |    | |/ _` | __) __)/ _ \        |  __  | `__) _ \/ _` |
 * | |____| | (_| |__ \__ \  __/        | |  | | | |  __/ (_| |
 *  \_____)_|\__,_|___/___/\___|        |_|  |_|_|  \___|\__,_|
 *
 *
 * Aquesta classe encapsula una àrea definida mitjançant les coordenades del punt superior esquerra i del punt
 * inferior dret.
 *
 * Les coordenades s'han d'entrar com a punts absoluts (x1, y1) i (x2, y2), tot i que per métodes "get" i "set"
 * també es poden entrar com a desplaçaments (x1, y1) i (ample i alt).
 *
 * Aporta el métode "AreaInArea" per a comprobar si dues àrees es solapen.
 *
 *
 * @author Miquel Abadal i Cervià
 */
public class Area {


    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //

    protected double left;
    protected double top;
    protected double right;
    protected double bottom;


    //   __  __      _            _                              _                    _
    //  |  \/  |    | |          | |                            | |                  | |
    //  | \  / | ___| |_ ___   __| | ___     ____ ___  _ __  ___| |_ _ __ _   _  ____| |_ ___  _ __
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \   / ___) _ \| `_  \ __) __) `__) | | |/ ___) __) _ \| `__)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | (___ (_) | | | |__ \ |_| |  | |_| | (___| |_ (_) | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|   \____)___/|_| |_|___/\__)_|   \__,_|\____)\__)___/|_|
    //
    //

    public Area (double left, double top, double right, double bottom) {

        if (left>right) {
            double buf = left;
            left = right;
            right = buf;
        }

        if (top>bottom) {
            double buf = top;
            top = bottom;
            bottom = buf;
        }

        this.left = left;
        this.top = top;
        this.right = right;
        this.bottom = bottom;


    }

    public Area (Point topLeft, Point bottomRight) {
        this.left = topLeft.x;
        this.top = topLeft.y;
        this.right = bottomRight.x;
        this.bottom = bottomRight.y;
    }


    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| (___ | |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)         \___ \|  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \         ____) | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/        (_____/|______)  |_|
    //
    //

    public void setLeft (double left) { this.left = left; }
    public void setTop (double top) { this.top = top; }
    public void setRight (double right) { this.right = right; }
    public void setBottom (double bottom) { this.bottom = bottom; }
    public void setWidth (double width) { this.right = left+width; }
    public void setHeight (double height) { this.bottom = top+height; }


    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| |  __| |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)        | | (_ |  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \        | |__| | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/         \_____|______)  |_|
    //
    //

    public double getLeft () { return left; }
    public double getTop () { return top; }
    public double getRight () { return right; }
    public double getBottom () { return bottom; }
    public double getWidth () { return right-left; }
    public double getHeight () { return bottom-top; }

    //   __  __      _            _                     _     _ _
    //  |  \/  |    | |          | |                   | |   | |_)
    //  | \  / | ___| |_ ___   __| | ___    _ __  _   _| |_  | |_  ____ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \  | `_ \| | | | `_ \| | |/ ___) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | |_) | |_| | |_) | | | (___\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|  |  __/ \__,_|_,__/|_|_|\____)___/
    //                                     | |
    //                                     |_|

    public boolean areaInArea (Area area) {
        return (left<=area.right && area.left<=right && top<=area.bottom && area.top<=bottom);
    }

}
