/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cat.lib.geometry;

/**
 *    _____ _                       _  _  _     _            _    _           _              _  _
 *   / ____) |                     | || || |   (_)          | |  | |         | |            | || |
 *  | |    | |  _ _ ___ ___  ___   |_||_|| |    _ _ __   ___| |  | |___  ____| |_ ___  _ __ |_||_|
 *  | |    | |/ _` | __) __)/ _ \        | |   | | `_  \/ _ \ |  | | _ \/ ___) __) _ \| `__)
 *  | |____| | (_| |__ \__ \  __/        | |___| | | | |  __/\ \/ /  __/ (___| |_ (_) | |
 *   \_____)_|\__,_|___/___/\___|        |_____)_|_| |_|\___| \__/ \___|\____)\__)___/|_|
 *
 *
 * La classe "LineVector" encapsula una linea definida com a vector a `òdul i argument.
 *
 * Aporta un métode per a obtenir una línea amb les seves coordenades absolutes. Se li pot indicar
 * les coordenades del primer punt o sinó interpreta que comença a la coordenada (0,0)
 *
 * @author Miquel Abadal i Cervià
 */
public class LineVector {

    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //

    protected double modul;
    protected double angle;


    //   __  __      _            _                              _                    _
    //  |  \/  |    | |          | |                            | |                  | |
    //  | \  / | ___| |_ ___   __| | ___     ____ ___  _ __  ___| |_ _ __ _   _  ____| |_ ___  _ __
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \   / ___) _ \| `_  \ __) __) `__) | | |/ ___) __) _ \| `__)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | (___ (_) | | | |__ \ |_| |  | |_| | (___| |_ (_) | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|   \____)___/|_| |_|___/\__)_|   \__,_|\____)\__)___/|_|
    //
    //

    public LineVector (double modul, double angle) {
        this.modul = modul;
        this.angle = angle;
    }

    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| (___ | |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)         \___ \|  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \         ____) | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/        (_____/|______)  |_|
    //
    //

    public void setModul (double modul) { this.modul = modul; }
    public void setAngle (double angle) { this.angle = angle; }


    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| |  __| |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)        | | (_ |  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \        | |__| | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/         \_____|______)  |_|
    //
    //

    public double getModul () { return modul; }
    public double getAngle () { return angle; }


    //   __  __      _            _                     _     _ _
    //  |  \/  |    | |          | |                   | |   | |_)
    //  | \  / | ___| |_ ___   __| | ___    _ __  _   _| |_  | |_  ____ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \  | `_ \| | | | `_ \| | |/ ___) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | |_) | |_| | |_) | | | (___\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|  |  __/ \__,_|_,__/|_|_|\____)___/
    //                                     | |
    //                                     |_|

    public Line toLine (double x1, double y1) {
        double x2 = x1 + (modul * Math.cos (angle));
        double y2 = y1 + (modul * Math.sin (angle));
        
        return new Line (x1, y1, x2, y2);
    }

    public Line toLine () { return toLine (0, 0);}


}
