/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cat.lib.geometry;

/**
 *
 * @author Administrador
 */
public class Polygon {



    //     __   _        _ _           _
    //   / __ \| |      (_) |         | |
    //  | |__| | |_ _ __ _| |_   _   _| |_ ___
    //  |  __  | __) `__) | `_ \| | | | __) __)
    //  | |  | | |_| |  | | |_) | |_| | |_\__ \
    //  |_|  |_|\__)_|  |_|_,__/ \__,_|\__)___/
    //
    //

    private Line[] lines = null;
    private Point[] points = null;


    //   __  __      _            _                              _                    _
    //  |  \/  |    | |          | |                            | |                  | |
    //  | \  / | ___| |_ ___   __| | ___     ____ ___  _ __  ___| |_ _ __ _   _  ____| |_ ___  _ __
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \   / ___) _ \| `_  \ __) __) `__) | | |/ ___) __) _ \| `__)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | (___ (_) | | | |__ \ |_| |  | |_| | (___| |_ (_) | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|   \____)___/|_| |_|___/\__)_|   \__,_|\____)\__)___/|_|
    //
    //

    public Polygon (Point[] points) {
        generateLines (points);
    }

    // Un poligon ha de tenir com a mímin 3 vertex (triangle)
    private void generateLines (Point[] points) {

        this.points = points;

        if (points!=null && points.length>1) {

            lines = new Line[points.length];

            for (int index=1; index<points.length; index++) {
                Line line = new Line (points[index-1], points[index]);
                lines[index-1] = line;
            }
            Line line = new Line (points[points.length-1], points[0]);
            lines[points.length-1] = line;

        }
        else { lines = null; }
    }

    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| (___ | |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)         \___ \|  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \         ____) | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/        (_____/|______)  |_|
    //
    //

    public void setPoints (Point[] points) { generateLines (points); }



    //   __  __      _            _             _  _   _____ ______ _______ _  _
    //  |  \/  |    | |          | |           | || | / ____)  ____)__   __) || |
    //  | \  / | ___| |_ ___   __| | ___ ___   |_||_|| |  __| |__     | |  |_||_|
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \ __)        | | (_ |  __)    | |
    //  | |  | |  __/ |_ (_) | (_| |  __/__ \        | |__| | |____   | |
    //  |_|  |_|\___|\__)___/ \__,_|\___|___/         \_____|______)  |_|
    //
    //

    public Point[] getPoints () { return points; }
    public Line[] getLines () { return lines; }

    //   __  __      _            _                     _     _ _
    //  |  \/  |    | |          | |                   | |   | |_)
    //  | \  / | ___| |_ ___   __| | ___    _ __  _   _| |_  | |_  ____ ___
    //  | |\/| |/ _ \ __) _ \ / _` |/ _ \  | `_ \| | | | `_ \| | |/ ___) __)
    //  | |  | |  __/ |_ (_) | (_| |  __/  | |_) | |_| | |_) | | | (___\__ \
    //  |_|  |_|\___|\__)___/ \__,_|\___|  |  __/ \__,_|_,__/|_|_|\____)___/
    //                                     | |
    //                                     |_|

    public boolean pointInPolygon (Point point) {

        int interseccions = 0;

        if (point!=null && lines!=null) {
            Line line = new Line (point.x, point.y, Double.MAX_VALUE, point.y);

            for (int index=0; index<lines.length; index++) {
                Line polygonLine = lines[index];
                if (polygonLine.lineIntersection(line)!=null) { interseccions++; }
            }
        }

        return (interseccions%2)==1;
    }
    
    public void dispose() {
  
        if (lines!=null) { for (int cont1=0; cont1<lines.length; cont1++) { lines[cont1] = null; } }
        if (points!=null) { for (int cont1=0; cont1<points.length; cont1++) { points[cont1] = null; } }
    }
}


