/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cat.lib.math;


/**
 *
 * @author Miquel Abadal i Cervià
 */
public class MathEx {

    final public static double CONST_GRAVITACIONAL = 6.67e-11;

    public static double round (double valor, int numDecimals) {
        int signe = +1;
        if (valor<0) { signe = -1; }
        valor = valor * signe;
        
        double factor = Math.pow(10, numDecimals);
        return ((Math.round (valor*factor)) / factor)*signe;
    }

    public static double round2Dec (double valor) { return (Math.round (valor*100)) / 100; }



    public static byte rang (byte valor, byte min, byte max) {
        if (max!=-1 && valor>max) valor=max;
        if (min!=-1 && valor<min) valor=min;
        return valor;
    }


    public static short rang (short valor, short min, short max) {
        if (max!=-1 && valor>max) valor=max;
        if (min!=-1 && valor<min) valor=min;
        return valor;
    }

    public static int rang (int valor, int min, int max) {
        if (max!=-1 && valor>max) valor=max;
        if (min!=-1 && valor<min) valor=min;
        return valor;
    }

    public static long rang (long valor, long min, long max) {
        if (max!=-1 && valor>max) valor=max;
        if (min!=-1 && valor<min) valor=min;
        return valor;
    }

    public static float rang (float valor, float min, float max) {
        if (max!=Float.NaN && valor>max) valor=max;
        if (max!=Float.NaN && valor<min) valor=min;
        return valor;
    }

    public static double rang (double valor, double min, double max) {
        if (max!=Double.NaN && valor>max) valor=max;
        if (min!=Double.NaN && valor<min) valor=min;
        return valor;
    }

    public static long divisio (long divisor, long divident) {
        return (long) (divisor/divident);
    }

    public static long resta  (long divisor, long divident) {
        return (long) (divisor % divident);
    }

    public static double sqrN (double valor, double base) {
        return Math.pow (Math.E, Math.log (valor)/base);
    }

    public static double hipotenusa (double a, double b) {
        return Math.hypot (a, b);
    }

    public static int percentInteger (int total, int percent) {
        return (int) (total*percent/100);
    }

    public static double percent (double total, double percent) {
        return total*percent/100;
    }

    public static double grausToRadians (double graus) {
        // trunca els graus perque estiguin dintre del rang 0--360
        int grausEnter = ((int) (graus / 360))*360;
        graus = graus - grausEnter;

        double radians = (2*Math.PI*graus) / 360;
        return radians;
    }

    public static double radiansToGraus (double radians) {
        return radians*180/Math.PI;
    }

    /**
    * Calcula la lluminositat d'un cos celeste en funció de la seva magnitud.
    *
    * Tenint en compte la fórmula:  lluminositat = 2.512 ^magnitud
    *
    * @param magnitud Magnitud del cos.
    */
    public static double lluminositat (double magnitud) {
        return Math.pow (2.512, magnitud);
    }


    /**
    * Calcula la superfície d'un cercle.
    *
    * Tenint en compte la fórmula:  superficie = PI x radi^2
    *
    * @param radi El radi de la esfera.
    */
    public static double superficieCercle (double radi) {
        return Math.PI * radi * radi;
    }

    /**
    * Calcula la superfície d'una esfera.
    * 
    * Tenint en compte la fórmula:  superficie = 4 x PI x radi^2
    *
    * @param radi El radi de la esfera.
    */    
    public static double superficieEsfera (double radi) {
        return 4 * Math.PI * radi * radi;
    }
    

    /**
    * Calcula el volum d'un cos en funció de la seva masa i densitat.
    *
    *                                            masa                     masa
    * Tenint en compte la fórmula:  densitat = ---------   --> volum = ------------
    *                                            volum                   densitat
    *
    * @param masa La masa del cos.
    * @param densitat La densitat del cos.
    */
    public static double volum (double masa, double densitat) { return masa / densitat; }


    
    /**
    * Calcula el volum d'un cos en funció de la seva masa i densitat.
    * 
    *                                            masa      
    * Tenint en compte la fórmula:  densitat = ---------   
    *                                            volum     
    *
    * @param masa La masa del cos.
    * @param volum Volum del cos.
    */    
    public static double densitat (double masa, double volum) { return masa / volum; }
    
    
    /**
    * Pasa un valor de densitat expresat en gr / cm3 a Kg / m3.
    * 
    *                                                 1 gr        1 Kg       1000 cm3     1000 dm3
    * Tenint en compte que:  densitat = densitat x --------- x  --------- x ---------- x ----------
    *                                                1 cm3       1000 gr       1 dm3       1 m3
    *
    * @param densitat La densitat expresada en gr/cm3
    */
    public static double grCm3_to_KgM3 (double densitat) { return densitat * 1000; }

    /**
    * Calcula el volum d'un cos en funció de la seva masa i densitat.
    * 
    *                                            masa      
    * Tenint en compte la fórmula:  densitat = ---------   -->  masa = densitat x volum  
    *                                            volum     
    *    
    * @param densitat La densitat del cos.
    * @param volum Volum del cos.
    */    
    public static double masa (double densitat, double volum) { return densitat * volum; }
    
        
    
    /**
    * Calcula el diametre d'un cos esféric en funció de la seva masa i densitat.    
    * 
    *                                              4                     masa
    * Tenint en compte la fórmula:  volumEsfera = ---- x PI x radi^3 = ---------
    *                                              3                    densitat 
    *                                                                             3              (1/3)
    * Finalment, després de desenvolupar la fórmula, obtenim:  diametre = 2 x (-------- x volum )^
    *                                                                           4 x PI      
    *
    * @param masa La masa del cos.
    * @param densitat La densitat del cos.
    */
    public static double diametre (double masa, double densitat) {

        double volum = volum (masa, densitat);
        double diametre = volum * (3 / (4 * Math.PI));
        diametre = 2 * Math.pow (diametre,1.0/3);
        return diametre;

    }

    /**
    * Calcula el diametre d'un cercle.
    *                                              
    * Tenint en compte la fórmula:  diametre = 2 x radi
    *                                              
    * @param radi Radi del cercle.    
    */
    public static double diametre (double radi) { return radi * 2; }


    /**
    * Calcula el radi d'un cercle.
    *
    *                                      diametre
    * Tenint en compte la fórmula:  radi= -----------
    *                                          2
    *
    * @param diametre Diametre del cercle.
    */
    public static double radi (double diametre) { return diametre / 2; }

    /**
    * Calcula el perímetre d'un cercle.
    *
    * Tenint en compte la fórmula:  perimetre = 2 x PI x radi
    *
    * @param radi Radi del cercle.
    */
    public static double perimetre (double radi) { return 2 * Math.PI * radi; }


    /**
    * Calcula la força de gravetat amb la qual un cos atrau a un altre situat
    * a la distància indicada.
    *
    *                                                                         masa
    * Tenint en compte la fórmula:  foçaGravetat= ConstantGravitacional x -------------
    *                                                                      distancia^2
    *
    * La constant gravitacional és una constants universal que pren el valor de 6.67e-11 Newtons m^2 / Kg^2
    *
    * Si la distància presa correspon al radi del cos, llavors estem calculant la força de gravetat amb la qual
    * el cos atrau als objectes situata a la seva superfície.
    *
    * @param masa La masa del cos.
    * @param distancia La distància a la qual volem mesura la gravetat.
    */
    public static double gravetatSuperficial (double masa, double distancia) {
        return CONST_GRAVITACIONAL * masa / Math.pow (distancia, 2);
    }

    public static double factorial (int valor) {

        double res = 1;
        for (int cont1 = 2; cont1<=valor; cont1++) {
            res = res * cont1;
        }
        return res;
    }
}
