//    _____ _                       _  _  _______ _                   ______      _  _
//   / ____) |                     | || |(__   __)_)                 |  ____)    | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|   | |   _ _ _ __   ___ _ __| |__  _   ___||_|
//  | |    | |/ _` | __) __)/ _ \           | |  | | ` `  \ / _ \ `__)  __) \ \/ /
//  | |____| | (_| |__ \__ \  __/           | |  | | |\ |\ |  __/ |  | |____ )  (
//   \_____)_|\__,_|___/___/\___|           |_|  |_|_||_||_|\___|_|  |______)_/\_\
//
//

package cat.lib.timers;

import java.util.Timer;

/**
 *
 * @author Miquel Abadal i Cervià
 */
public class TimerEx {

    public static final int STARTED = 1;
    public static final int STOPPED = 0;

    int status = STOPPED;

    TimerTaskEx task = null;

   public void start (Timezable timezableObject, int delay, int period, boolean fixedRate) {
        if (task==null) {

            task = new TimerTaskEx (this, timezableObject);
            Timer timer = new Timer();

            if (fixedRate) { timer.scheduleAtFixedRate (task, delay, period); }
            else { timer.schedule(task, delay, period); }
            
            status=STARTED;
        }
    };

   public void start (Timezable timezableObject, int delay, int period) { start (timezableObject, delay, period, true); }
   public void start (Timezable timezableObject, int period) { start (timezableObject, period, period, true); }

    public void stop () {

        if (task!=null) {
            task.cancel();
            task=null;
            status=STOPPED;
        }
    }


    public int getStatus () { return status; }

}
