//    _____ _                       _  _  ____                            _    _ _   _ _    _  _
//   / ____) |                     | || ||  __ \                         | |  | | | (_) |  | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|| |__) |___  _ _ __    _ _ _ __ | |  | | |_ _| |____||_|
//  | |    | |/ _` | __) __)/ _ \        |  _  // _ \| ` `  \ / _` | `_  \ |  | | __) | | __)
//  | |____| | (_| |__ \__ \  __/        | | \ \ (_) | |\ |\ | (_| | | | | |__| | |_| | |__ \
//   \_____)_|\__,_|___/___/\___|        |_|  \_\___/|_||_||_|\__,_|_| |_|\____/ \__)_|_|___/
//
//


package cat.lib.utils;

import cat.lib.math.*;
import java.math.BigDecimal;


/**
 * La classe <code>RomanUtils</code> conté métodes estàtics que permet convertir
 * un número enter a números romans, i un número roma enmagatzemat en una cadena
 * de text a un número enter.
 *
 * @author  Miquel Abadal i Cervià
 * @version 1.0, 06/12/09
 * @since JDK1.0
 */
public class RomanUtils {


    public static String intToRoman (int value) {
        String res;
        try { res = Roman.parseRoman(value); }
        catch (NumberFormatException ex) { res = ""; }
        return res;
    }

    public static int romanToInt (String value) {
        int res;
        try { res = Roman.parseInt (value); }
        catch (NumberFormatException ex) { res = -1; }

        return res;
    }
}
