//    _____ _                       _  _   _____      _   _    _ _   _ _    _  _
//   / ____) |                     | || | / ____)    | | | |  | | | (_) |  | || |
//  | |    | |  _ _ ___ ___  ___   |_||_|| (___   ___| |_| |  | | |_ _| |____||_|
//  | |    | |/ _` | __) __)/ _ \         \___ \ / _ \ __) |  | | __) | | __)
//  | |____| | (_| |__ \__ \  __/         ____) |  __/ |_| |__| | |_| | |__ \
//   \_____)_|\__,_|___/___/\___|        (_____/ \___|\__)\____/ \__)_|_|___/
//
//


package cat.lib.utils;

import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Vector;


/**
 *
 * @author Miquel Abadal i Cervià
 */
public class SetUtils  {

    //    _____                           _                     _
    //   / ____)                         | |                   | |
    //  | |     ___ _ __ ____  _ _     __| | ___    _    _  _ _| | ___  _ __ ___     ___ _ __     _   _ _ __
    //  | |    / _ \ `__) ___) _` |   / _` |/ _ \  | |  | | _` | |/ _ \| `__) __)   / _ \ `_  \  | | | | `_  \
    //  | |____  __/ | | (___ (_| |  | (_| |  __/   \ \/ / (_| | | (_) | |  \__ \  |  __/ | | |  | |_| | | | |
    //   \_____)___|_|  \____)__,_|   \__,_|\___|    \__/ \__,_|_|\___/|_|  (___/   \___|_| |_|   \__,_|_| |_|
    //
    //    _  _    __                       _  _
    //   | || | / __ \                    | || |
    //   |_||_|| |__| |_ __ _ __  _ _ _   __||_|
    //         |  __  | `__) `__) _` | | | |
    //         | |  | | |  | | | (_| | |_| |
    //         |_|  |_|_|  |_|  \__,_|\__, |
    //                                 __/ |
    //                                (___/


    /**
     * Busca si el caracter <code>caract</code> apareix a la taula de caràcters
     * <code>conjuntCaract</code>. Si el troba en retorna la seva posició i en
     * cas contrari retorna un <code>-1</code>
     *
     * @param caract
     * @param caseSensitive
     * @param conjuntCaract
     * @return
     */
    public static int searchCharInArray (char caract, boolean caseSensitive, char[] conjuntCaract) {

        int trobat = -1;
        int cont1 = 0;

        if (conjuntCaract!=null) {
            if (caseSensitive) {
                while (trobat==-1 && cont1<conjuntCaract.length) {
                    if (caract==conjuntCaract[cont1]) { trobat = cont1; }
                    cont1++;
                }
            }
            else {
                caract = StringUtils.toLowerCase (caract);

                while (trobat==-1 && cont1<conjuntCaract.length) {
                    if (caract==StringUtils.toLowerCase (conjuntCaract[cont1])) { trobat = cont1; }
                    cont1++;
                }
            }
        }
        return trobat;
    }

    /**
     * Busca si la cadena <code>text</code> apareix a la taula de cadenes
     * <code>conjuntText</code>. Si la troba en retorna la seva posició i en
     * cas contrari retorna un <code>-1</code>
     *
     * @param text
     * @param caseSensitive
     * @param conjuntText
     * @return
     */
    public static int searchStringInArray (String text, boolean caseSensitive, String[] conjuntText) {

        int trobat = -1;
        int cont1 = 0;

        if (conjuntText!=null) {
            if (caseSensitive) {
                while (trobat==-1 && cont1<conjuntText.length) {
                    if (text.equals (conjuntText[cont1])) { trobat = cont1; }
                    cont1++;
                }
            }
            else {
                text = StringUtils.toLowerCase (text);

                while (trobat==-1 && cont1<conjuntText.length) {
                    if (text.equals (StringUtils.toLowerCase (conjuntText[cont1]))) { trobat = cont1; }
                    cont1++;
                }
            }
        }

        return trobat;
    }

    public static int searchIntegerInArray (int value, int[] conjuntInt) {

        int trobat = -1;
        int cont1 = 0;

        if (conjuntInt!=null) {
            while (trobat==-1 && cont1<conjuntInt.length) {
                if (value==conjuntInt[cont1]) { trobat = cont1; }
                cont1++;
                
            }
        }

        return trobat;
    }
    
    /**
     * Comproba si el caràcter "caract" està inclos en el conjunt "conjuntCaract".
     *
     * Ejemple:
     *    char carcter = 'A';
     *    boolean trobat = valueIn (caracter, {'A', 'E', 'I', 'O', 'U'});
     *    --> Retorna a true perque 'A' forma part del conjunt de vocals
     *
     * @param caract Caracter a verificar si està inclos en el conjunt.
     * @return  Retorna <code>true</code> si el caràcter està inclos en el conjunt,
     * o <code>false</code> en cas contrari.
     */
    public static boolean charInArray (char caract, boolean caseSensitive, char[] conjuntCaract) {

        return (searchCharInArray (caract, caseSensitive, conjuntCaract)!=-1);
    }

    public static boolean stringInArray (String text, boolean caseSensitive, String[] conjuntText) {

        return (searchStringInArray (text, caseSensitive, conjuntText)!=-1);
    }

    public static boolean intInArray (int value, int[] conjuntInt) {

        return (searchIntegerInArray (value, conjuntInt)!=-1);
    }

    //    _____                           _                     _
    //   / ____)                         | |                   | |
    //  | |     ___ _ __ ____  _ _     __| | ___    _    _  _ _| | ___  _ __ ___     ___ _ __     _   _ _ __
    //  | |    / _ \ `__) ___) _` |   / _` |/ _ \  | |  | | _` | |/ _ \| `__) __)   / _ \ `_  \  | | | | `_  \
    //  | |____  __/ | | (___ (_| |  | (_| |  __/   \ \/ / (_| | | (_) | |  \__ \  |  __/ | | |  | |_| | | | |
    //   \_____)___|_|  \____)__,_|   \__,_|\___|    \__/ \__,_|_|\___/|_|  (___/   \___|_| |_|   \__,_|_| |_|
    //
    //    _  _    __                               _                                            _               _  _
    //   | || | / __ \                            | |                                          | |             | || |
    //   |_||_|| |__| |_ __ _ __  _ _ _   _     __| | ___    _ __    _ _ _ __  _ _ _ _ __   ___| |_ _ __ ___ ____||_|
    //         |  __  | `__) `__) _` | | | |   / _` |/ _ \  | `_ \ / _` | `__) _` | ` `  \ / _ \ __) `__) _ \ __)
    //         | |  | | |  | | | (_| | |_| |  | (_| |  __/  | |_) | (_| | | | (_| | |\ |\ |  __/ |_| | |  __/__ \
    //         |_|  |_|_|  |_|  \__,_|\__, |   \__,_|\___|  |  __/ \__,_|_|  \__,_|_||_||_|\___|\__)_|  \___|___/
    //                                 __/ |                | |
    //                                (___/                 |_|

    public static int searchCharIn (char caract, boolean caseSensitive, char... conjuntCaract) {

        int trobat = -1;
        int cont1 = 0;

        if (caseSensitive) {
            while (trobat==-1 && cont1<conjuntCaract.length) {
                if (caract==conjuntCaract[cont1]) { trobat = cont1; }
                cont1++;
            }
        }
        else {
            caract = StringUtils.toLowerCase (caract);

            while (trobat==-1 && cont1<conjuntCaract.length) {
                if (caract==StringUtils.toLowerCase (conjuntCaract[cont1])) { trobat = cont1; }
                cont1++;
            }
        }
        return trobat;
    }

    public static int searchCharIn (char caract, boolean caseSensitive, String conjuntCaract) {

        int trobat = -1;
        int cont1 = 0;

        if (caseSensitive) {
            while (trobat==-1 && cont1<conjuntCaract.length()) {
                if (caract==conjuntCaract.charAt(cont1)) { trobat = cont1; }
                cont1++;
            }
        }
        else {
            caract = StringUtils.toLowerCase (caract);

            while (trobat==-1 && cont1<conjuntCaract.length()) {
                if (caract==StringUtils.toLowerCase (conjuntCaract.charAt(cont1))) { trobat = cont1; }
                cont1++;
            }
        }
        return trobat;
    }

    /**
     * Busca si la cadena <code>text</code> apareix a la taula de cadenes
     * <code>conjuntText</code>. Si la troba en retorna la seva posició i en
     * cas contrari retorna un <code>-1</code>
     *
     * @param text
     * @param caseSensitive
     * @param conjuntText
     * @return
     */
    public static int searchStringIn (String text, boolean caseSensitive, String...conjuntText) {

        int trobat = -1;
        int cont1 = 0;

        if (caseSensitive) {
            while (trobat==-1 && cont1<conjuntText.length) {
                if (text.equals (conjuntText[cont1])) { trobat = cont1; }
                cont1++;
            }
        }
        else {
            text = StringUtils.toLowerCase (text);

            while (trobat==-1 && cont1<conjuntText.length) {
                if (text.equals (StringUtils.toLowerCase (conjuntText[cont1]))) { trobat = cont1; }
                cont1++;
            }
        }
        return trobat;
    }

    /**
     * Comproba si el caràcter "caract" està inclos en el conjunt "conjuntCaract".
     *
     * Ejemple:
     *    char carcter = 'A';
     *    boolean trobat = valueIn (caracter, {'A', 'E', 'I', 'O', 'U'});
     *    --> Retorna a true perque 'A' forma part del conjunt de vocals
     *
     * @param caract Caracter a verificar si està inclos en el conjunt.
     * @return  Retorna <code>true</code> si el caràcter està inclos en el conjunt,
     * o <code>false</code> en cas contrari.
     */
    public static boolean charIn (char caract, boolean caseSensitive, char... conjuntCaract) {

        return (searchCharIn (caract, caseSensitive, conjuntCaract)!=-1);
    }

    public static boolean stringIn (String text, boolean caseSensitive, String... conjuntText) {

        return (searchStringIn (text, caseSensitive, conjuntText)!=-1);
    }

    public static boolean charIn (char caract, boolean caseSensitive, String text) {

        return (searchCharIn (caract, caseSensitive, text)!=-1);
    }

    
    //    _____                           _                     _
    //   / ____)                         | |                   | |
    //  | |     ___ _ __ ____  _ _     __| | ___    _    _  _ _| | ___  _ __ ___     ___ _ __     _   _ _ __
    //  | |    / _ \ `__) ___) _` |   / _` |/ _ \  | |  | | _` | |/ _ \| `__) __)   / _ \ `_  \  | | | | `_  \
    //  | |____  __/ | | (___ (_| |  | (_| |  __/   \ \/ / (_| | | (_) | |  \__ \  |  __/ | | |  | |_| | | | |
    //   \_____)___|_|  \____)__,_|   \__,_|\___|    \__/ \__,_|_|\___/|_|  (___/   \___|_| |_|   \__,_|_| |_|
    //
    //    _  _  ______                                    _   _           _  _
    //   | || ||  ____)                                  | | (_)         | || |
    //   |_||_|| |__   _ __  _   _ _ _ __   ___ _ __  _ _| |_ _  ___  _ ___||_|
    //         |  __) | `_  \ | | | ` `  \ / _ \ `__) _` | __) |/ _ \| `_  \
    //         | |____| | | | |_| | |\ |\ |  __/ | | (_| | |_| | (_) | | | |
    //         |______)_| |_|\__,_|_||_||_|\___|_|  \__,_|\__)_|\___/|_| |_|
    //
    //

    /**
     * Busca a dintre de la llista d'elements d'un Enumeration si n'existeix
     * algun amb el contingut indicat amb el paràmetre <code>text</code>,
     * cercant-lo amb la mateixa tipografia o no seguns el parametre
     * <code>caseSensitive</code>.
     *
     * En cas de trobar-lo retorna el text amb la mateixa tipografia en la que
     * està enmagatzemat dintre del enumeration; i en cas de no trobarla retorna
     * un valor a <code>null</code>.
     *
     * <code>NOTA:</code> També ignora, a l'hora de comparar els elements, els
     * espais en blanc que hi pugui haber al principi i final de les cadenes,
     * tot i que el valor retornat tindrà els espais.
     *
     * <code>NOTA:</code> Si la llista conté objectes que no són de la classe
     * String, els ignora.
     *
     * @param text Text a cercar
     * @param list LLista de cadenes en la que cercar.
     * @param caseSensitive <code>true</code> si la recerca ha de tenir en compte
     * la tipografia <code>false</code> en cas contrari.
     * @return La cadena de text trobada amb la tipografia amb la qual està
     * enmagatzemada dintre del llistat.
     */
    public static String stringInEnumeration (String text, Enumeration list, boolean caseSensitive) {

        String name;
        Object obj = null;
        String trobat = null;

        if (text!=null && list!=null) {

            if (caseSensitive) {
                while ((trobat==null) && (list.hasMoreElements())) {
                    obj = list.nextElement();
                    if (obj instanceof String) {
                        name = (String) obj;
                        if (name.trim().equals(text)) { trobat = name; }
                    }
                }
            }
            else {
                text = StringUtils.toLowerCase (text);

                while ((trobat==null) && (list.hasMoreElements())) {
                    obj = list.nextElement();
                    if (obj instanceof String) {
                        name = (String) obj;
                        if (StringUtils.toLowerCase (name).equals (text)) { trobat = name; }
                    }
                }
            }
        }
        return trobat;

    }

    //    _____                           _                     _
    //   / ____)                         | |                   | |
    //  | |     ___ _ __ ____  _ _     __| | ___    _    _  _ _| | ___  _ __ ___     ___ _ __     _   _ _ __
    //  | |    / _ \ `__) ___) _` |   / _` |/ _ \  | |  | | _` | |/ _ \| `__) __)   / _ \ `_  \  | | | | `_  \
    //  | |____  __/ | | (___ (_| |  | (_| |  __/   \ \/ / (_| | | (_) | |  \__ \  |  __/ | | |  | |_| | | | |
    //   \_____)___|_|  \____)__,_|   \__,_|\___|    \__/ \__,_|_|\___/|_|  (___/   \___|_| |_|   \__,_|_| |_|
    //
    //    _  _   _____      _ _            _   _           _  _
    //   | || | / ____)    | | |          | | (_)         | || |
    //   |_||_|| |     ___ | | | ___  ____| |_ _  ___  _ ___||_|
    //         | |    / _ \| | |/ _ \/ ___) __) |/ _ \| `_  \
    //         | |____ (_) | | |  __/ (___| |_| | (_) | | | |
    //          \_____)___/|_|_|\___|\____)\__)_|\___/|_| |_|
    //
    //

    public static String stringInCollection (String text, Collection list, boolean caseSensitive) {

        String trobat = null;

        if (list!=null) {
            Iterator iterator = list.iterator();
            while (iterator.hasNext()) {
                Map.Entry e = (Entry) iterator.next();
                String name = (String) e.getValue();
                if (StringUtils.lowerCase (name.trim(), caseSensitive).equals (text)) { trobat = name; }
            }
        }

        return trobat;
    }

    //    _____                           _                     _
    //   / ____)                         | |                   | |
    //  | |     ___ _ __ ____  _ _     __| | ___    _    _  _ _| | ___  _ __ ___     ___ _ __     _   _ _ __
    //  | |    / _ \ `__) ___) _` |   / _` |/ _ \  | |  | | _` | |/ _ \| `__) __)   / _ \ `_  \  | | | | `_  \
    //  | |____  __/ | | (___ (_| |  | (_| |  __/   \ \/ / (_| | | (_) | |  \__ \  |  __/ | | |  | |_| | | | |
    //   \_____)___|_|  \____)__,_|   \__,_|\___|    \__/ \__,_|_|\___/|_|  (___/   \___|_| |_|   \__,_|_| |_|
    //
    //    _  _  __  __                  _  _
    //   | || ||  \/  |                | || |
    //   |_||_|| \  / |  _ _ _ __    _ __||_|
    //         | |\/| |/ _` | `_ \ / _` |
    //         | |  | | (_| | |_) | (_| |
    //         |_|  |_|\__,_|  __/ \__,_|
    //                      | |
    //                      |_|

    public static Object getMapValue (String key, Map map, boolean caseSensitive) {

        Object trobat = null;

        if (map!=null) {
            if (!caseSensitive) {
                key = key.toLowerCase();

                Iterator iterator = map.entrySet().iterator();
                while (trobat==null && iterator.hasNext()) {
                    Map.Entry e = (Entry) iterator.next();
                    String mapKey = (String) e.getKey();
                    if (mapKey.toLowerCase().equals (key)) { trobat = e.getValue(); }
                }
            }
            else { trobat = map.get(key); }
        }

        return trobat;
    }


    //    _____                           _                     _
    //   / ____)                         | |                   | |
    //  | |     ___ _ __ ____  _ _     __| | ___    _    _  _ _| | ___  _ __ ___     ___ _ __     _   _ _ __
    //  | |    / _ \ `__) ___) _` |   / _` |/ _ \  | |  | | _` | |/ _ \| `__) __)   / _ \ `_  \  | | | | `_  \
    //  | |____  __/ | | (___ (_| |  | (_| |  __/   \ \/ / (_| | | (_) | |  \__ \  |  __/ | | |  | |_| | | | |
    //   \_____)___|_|  \____)__,_|   \__,_|\___|    \__/ \__,_|_|\___/|_|  (___/   \___|_| |_|   \__,_|_| |_|
    //
    //    _  _  _    _           _            _  _
    //   | || || |  | |         | |          | || |
    //   |_||_|| |  | |___  ____| |_ ___  _ ___||_|
    //         | |  | | _ \/ ___) __) _ \| `__)
    //          \ \/ /  __/ (___| |_ (_) | |
    //           \__/ \___|\____)\__)___/|_|
    //
    //

    public static boolean stringInVector (String text, Vector vector, boolean caseSensitive) {

        String res = null;
        if (vector!=null) {
            Enumeration llista = vector.elements();
            res = stringInEnumeration (text, llista, caseSensitive);
        }
        
        return (res!=null);
    }

    
    //   ____             _ _                             _                    _
    //  |  __ \          | |_)                           | |                  | |
    //  | |__) |___ _ __ | |_  ____  _ _ _ __     ___ ___| |_ _ __ _   _  ____| |_ _   _ _ __ ___ ___      _ _
    //  |  _  // _ \ `_ \| | |/ ___) _` | `__)   / _ \ __) __) `__) | | |/ ___) __) | | | `__) _ \ __)   / _` |
    //  | | \ \  __/ |_) | | | (___ (_| | |     |  __/__ \ |_| |  | |_| | (___| |_| |_| | | |  __/__ \  | (_| |
    //  |_|  \_\___|  __/|_|_|\____)__,_|_|      \___|___/\__)_|   \__,_|\____)\__)\__,_|_|  \___|___/   \__,_|
    //             | |
    //             |_|
    //                  _  _    __                       _  _         _ _       _                         _
    //                 | || | / __ \                    | || |       | | |     | |                       | |
    //   _   _ _ __    |_||_|| |__| |_ __ _ __  _ _ _   __||_|     __| |_|  ___| | ___ _ _ __   ___ _ __ | |_ ___
    //  | | | | `_  \        |  __  | `__) `__) _` | | | |        / _` |   / _ \ |/ _ \ ` `  \ / _ \ `_  \ __) __)
    //  | |_| | | | |        | |  | | |  | | | (_| | |_| |       | (_| |  |  __/ |  __/ |\ |\ |  __/ | | | |_\__ \
    //   \__,_|_| |_|        |_|  |_|_|  |_|  \__,_|\__, |        \__,_|   \___|_|\___|_||_||_|\___|_| |_|\__)___/
    //                                               __/ |
    //                                              (___/

    /**
     * Crea una taula eamb els elements del Vector "vector".
     *
     * Si el "vector" indicat és null, retorna una taula amb zero elements.
     */
    public static Object[] VectorToArray (Vector vector) {

        Object[] res = null;

        if (vector!=null) {
            res = new Object[vector.size()];
            for (int cont1=0; cont1<vector.size(); cont1++) { res[cont1] = vector.get(cont1); }
        }
        else { res = new Object[0]; }

        return res;
    }


    /**
     * Crea una taula en la que hi inserta NOMËS els elements del Vector "vector"
     * que són de la classe "classOfObjects".
     *
     * Si el "vector" indicat és null, retorna una taula amb zero elements.
     */
    public static Object[] VectorToArray (Vector vector, Class classOfObjects) {

        Object[] res = null;

        if (vector!=null) {
            // Calcula el tamany que ha de tenir el array.
            int numElements = 0;
            for (int cont1=0; cont1<vector.size(); cont1++) {
                Object object = vector.get(cont1);
                if (object.getClass()==classOfObjects) { numElements++; }
            }

            int index = 0;
            res = new Object[numElements];
            for (int cont1=0; cont1<vector.size(); cont1++) {
                Object object = vector.get(cont1);
                if (object.getClass()==classOfObjects) {
                    res[index] = object;
                    index++;
                }
            }
        }
        else { res = new Object[0]; }

        return res;
    }


    /**
     * Converteix una cadena de text en la que hi ha una sèrie de paràmetres separats per caràcters
     * a un mapa amb els paràmetres.
     * Si el paràmetre conté el signe "=" i un valor, aquest es separa amb clau/valor.
     * 
     * Ejemple:
     * 
     * La cadena "PR|BA|CA" crea un mapa amb els tres elements amb valor null.
     * La cadena "PR=12|BA=20|CA=Hola que tal" crea un mapa amb els tres elements amb els corresponents valors assignats
     * 
     * Si no s'indica clau el valor s'assigna amb la clau "null", però en un mapa, només hi pot haber un element
     * amb clau "null".
     * 
     * Si s'indica un paràmetre sense clau ni valor, simplemet s'ignora
     * 
     */
    public static Map paramStringToMap (String text, char separador) {

        Map mapa = new HashMap();

        boolean onKey = true;
        boolean onValue = false;

        StringBuilder keyBuilder = new StringBuilder();
        StringBuilder valueBuilder = new StringBuilder();

        char caract = '\0';
        for (int cont1=0; cont1<text.length(); cont1++) {

            caract = text.charAt(cont1);
            if (caract==separador) {

                if (keyBuilder.length()>0 && valueBuilder.length()>0) {
                    String key = null;
                    String value = null;
                    if (keyBuilder.length()>0) { key = keyBuilder.toString(); }
                    if (valueBuilder.length()>0) { value = valueBuilder.toString(); }
                    mapa.put (key, value);
                }

                keyBuilder.setLength(0);
                valueBuilder.setLength(0);

                onKey = true;
                onValue = false;
            }
            else if(caract=='=') { onKey = false; onValue = true; }
            else if (onKey) { keyBuilder.append(caract); }
            else if (onValue) { valueBuilder.append(caract); }
        }


        if (keyBuilder.length()>0 && valueBuilder.length()>0) {
            String key = null;
            String value = null;
            if (keyBuilder.length()>0) { key = keyBuilder.toString(); }
            if (valueBuilder.length()>0) { value = valueBuilder.toString(); }
            mapa.put (key, value);
        }

        return mapa;
    }

    public static Vector mapToVector (Map mapa) {

        Vector llista = new Vector();

        Iterator i = mapa.entrySet().iterator();
        while (i.hasNext()) {
            Map.Entry entry = (Map.Entry) i.next();
            llista.add (entry.getValue());
        }
        return llista;
    }
}
