/*
 *  _____       _             ___ _       _         _  _  ____                           _     _     _  _
 * (_   _)     | |           / __)_)     (_)       | || ||  __ \                        | |   | |   | || |
 *   | |  _ __ | |_ ___ _ __| |_  _  ____ _  ___   |_||_|| |__) |_ _ _ __ ___  ___   _ _| |_  | | ____||_|
 *   | | | `_  \ __) _ \ `__)  _|| |/ ___) |/ _ \        |  ___/ _` | `__) __)/ _ \/ _` | `_ \| |/ _ \
 *  _| |_| | | | |_  __/ |  | |  | | (___| |  __/        | |  | (_| | |  \__ \  __/ (_| | |_) | |  __/
 * (_____)_| |_|\__)___|_|  |_|  |_|\____)_|\___|        |_|   \__,_|_|  (___/\___|\__,_|_,__/|_|\___|
 *
 *
 */

package cat.lib.xml;

/**
 * Aquesta interfície defineix els métodes que han d'implementar les classes que volguin
 * interceptar les seqüències d'etiquetes d'un fitxer Xml.
 *
 * En aquest cas, la classe "XmlParserEx" processa el fitxer Xml, i per cada node detectar
 * invoca el métode "onParse".
 *
 *
 * @author Miquel Abadal Cervià
 * @date 16-03-2010
 */
public interface Parseable {

    /**
     * Event "onParse".<br>
     * Es produeix cada cop que le classe "XmlParserEx" detecta l'inici o el tancament
     * d'una etiqueta.
     *
     * @param node Referencia el node detectat. Aquesta instància de tipus "XmlNode"
     * conté el path, el nom de la etiqueta, el seu valor i el tipus.
     *
     * @return Si volem que un cop generat aquest event, el intérpret dóni per completat el
     * procés cal retornar <b>true</b>.
     */
    public boolean onParse (String path, String value, int type);

}
